#include <iostream>
#include <math.h>
#include <string>
using namespace std;

class Pacijent{
public:
    string grupa;
    int kol;
    string rez;
};
int main()
{
      int B;
    cin >> B;
    int zaO, zaA, zaB, zaAB;
    cin >> zaO >> zaA >> zaB >> zaAB;
    Pacijent pacijent[10000];
    int Pac = 0;
    for (int i = 0; i < B; i++)
    {
        if (Pac >= B)
            break;
        cin >> pacijent[i].grupa >> pacijent[i].kol;
        Pac++;
    }
    for (int i = 0; i < B; i++)
    {
        if (pacijent[i].grupa == "O")
        {
            zaO -= pacijent[i].kol;
            if (zaO < 0)
            {
                zaO += pacijent[i].kol;
                pacijent[i].rez = "nemoguce";
            }
            else pacijent[i].rez = pacijent[i].kol + " 0 0 0";
        }
        if (pacijent[i].grupa == "A")
        {
            zaA -= pacijent[i].kol;
            if (zaA < 0)
            {
                int raz = abs(0 - zaA);
                zaA += raz;
                if (raz <= zaO)
                {
                    zaO -= raz;
                    if (zaO < 0)
                    {
                        pacijent[i].rez = "nemoguce";
                        break;
                    }
                    else {
                        int rew = (pacijent[i].kol - raz);
                        pacijent[i].rez = to_string(raz) + " " + to_string(rew) + " 0 0";
                    }
                }
            }
            else {
                {
                    pacijent[i].rez = "0 " + to_string(pacijent[i].kol) + " 0 0";
                }
            }
        }
        if (pacijent[i].grupa == "B")
        {
            zaA -= pacijent[i].kol;
            if (zaA < 0)
            {
                int raz = abs(0 - zaA);
                zaA += raz;
                if (raz <= zaO)
                {
                    zaO -= raz;
                    if (zaO < 0)
                    {
                        pacijent[i].rez = "nemoguce";
                    }
                    else {
                        int rew = (pacijent[i].kol - raz);
                        pacijent[i].rez = to_string(raz) + " 0" + to_string(rew) + " 0";
                    }
                }
            }
            else {
                {
                    pacijent[i].rez = "0 0 " + to_string(pacijent[i].kol) + " 0";
                }
            }
        }
        if (pacijent[i].grupa == "AB")
        {
            zaAB -= pacijent[i].kol;
            if (zaAB < 0)
            {
                int raz = abs(0 - zaAB);
                zaAB += raz;
                zaO -= raz;
                if (zaO < 0)
                {
                    int raz2 = abs(0 - zaO);
                    zaO += raz2;
                    zaA -= raz2;
                    if (zaA < 0)
                    {
                        int raz3 = abs(0 - zaA);
                        zaA += raz3;
                        zaB -= raz3;
                        if (zaB < 0)
                        {
                            pacijent[i].rez = "nemoguce";
                        }
                        else
                        {
                            int raz4 = abs(raz - raz2 - raz3);
                            pacijent[i].rez = to_string(raz2) + to_string(raz3) + to_string(raz4) + to_string(pacijent[i].kol - raz);
                        }
                    }
                    else {
                        pacijent[i].rez = to_string(raz2) + to_string(raz - raz2) + " 0 " + to_string(pacijent[i].kol - raz);
                    }
                }
                else {
                    pacijent[i].rez = to_string(raz) + " 0 0 " + to_string(pacijent[i].kol - raz);
                }
                
            }
            else {
                pacijent[i].rez = "0 0 0 0 " + to_string(pacijent[i].kol);
            }
        }
    }
    for (size_t i = 0; i < B; i++)
    {
        if (pacijent[i].rez == "nemoguce")
        {
            cout << pacijent[i].rez;
            return 0;
        }
    }
    cout << "moguce" << endl;
    for (size_t i = 0; i < B; i++)
    {
       cout << pacijent[i].rez << endl; 
    }
}